<?php


use Symfony\Component\HttpFoundation\RedirectResponse;
use Symfony\Component\HttpFoundation\JsonResponse;

// Set
// http://d9.playground/private_dns/set/10.0.0.44/cubo/d41d8cd98f00b204e9800998ecf8427e

// Get
// http://d9.playground/private_dns/get/0/cubo/00




/**
 * @file
 * Contains \Drupal\private_dns\Controller\PrivateDnsController.
 */
namespace Drupal\private_dns\Controller;

class PrivateDnsController {


  public function set ($ip , $name , $key)  {

    if ( private_dns_validate_key($key, "g") == false   )  {
      echo "Err:43gh";
      exit;
    }


    $timestamp =  private_dns_get_timestamp([]);
    $args      = private_dns_get_args();
    #dump($args);exit;
    $ip        = $args[2];
    $name      = $args[3];
    $key       = $args[4];

    private_dns_validate_key($key, "s");
    private_dns_validate_ip($ip,  "s");


    \Drupal::state()->set('private_dns_ip_0'  , $ip);
    \Drupal::state()->set('private_dns_name_0', $name);
    \Drupal::state()->set('private_dns_key_0' , $key);
    \Drupal::state()->set('private_dns_timestamp_0' , $timestamp);
    echo "Thanks!";    exit;
  }




  public function get ($ip , $name , $key)  {

    if ( private_dns_validate_key($key, "g") == false   )  {
      echo "Err:43gh";
      exit;
    }

    $data = [];
    $data['ip']   = \Drupal::state()->get('private_dns_ip_0'  , null);
    $data['name'] = \Drupal::state()->get('private_dns_name_0', null);
    $data['key']  = \Drupal::state()->get('private_dns_key_0' , null);
    // we only need a verfy basic output here...
    echo $data['ip'];
    exit;
  }


  /*
  * This function proposes a script to update local host file
  * we start using approach at https://stackoverflow.com/a/28459928/195812
  */
  public function create_file_hosts_script ($name, $key)  {
    
 
    //never cache this page
    \drupal::service('page_cache_kill_switch')->trigger();


    $host = \drupal::request()->gethost();
    $domain_with_schema = \drupal::request()->getschemeandhttphost();
    $args    = private_dns_get_args();

    if (!isset( $args[2]))  {
      $args[2] = "-";
    }

    $output = '' ;
    $output .= '<h1>' . t('flow') . '</h1>'  ;
    $output .= '<h2><b>a.</b> '.t('Update the private dns table from the server behind the dynamic ip. useful when run via crontab.', []).'</h2>';
    $script  = "<br/><br/><code>\r\n";
    $script .= "#! /bin/bash<br/>";

    $script .= "#tips:<br/>";
    $script .= "# on ubuntu you can: hosname.domain with<br/>";
    $script .= "## set hosname.domain with<br/>";
    $script .= "### \"sudo hostnamectl set-hostname MYHOSTNAME.DOMAIN\" <br/>";
    $script .= "### then reboot. <br/>";

    $script .= "## set up your crontab wvery 30 minuted with <br/>";
    $script .= "### \"0,30 * * * * /path/to/your/script\" <br/>";

    //
    // 0,30 * * * * /home/a/github.com/archivio/scripts/private_dns/private_dns_set_server_ip_cubo.sav72.sh




    $script .= "<br/>";
    $script .= "<br/>";

    //https://unix.stackexchange.com/a/38237/47662
    //$script .= "NAME=`uname -n`.`awk '/^domain/ {print $2}' /etc/resolv.conf` <br/>\r\n";
    //$script .= "wget -qO-  ". $domain_with_schema.PRIVATE_DNS_BASE_CALL."/set/\${NAME}/". PRIVATE_DNS_KEY   ."<br/>";

    $script .= "wanip='dig @resolver4.opendns.com myip.opendns.com +short';";
    $script .= "WMY_PUBLIC_IP=$(eval \"\$wanip\");";
    $script .= "NAME=`uname -n`;";
    $script .= "wget -qO- https://bbsavoia.it/private_dns/set/\${MY_PUBLIC_IP}/\${NAME}/d41d8cd98f00b204e9800998ecf8427e";
    $script .= "return ;";


    $script .= "</code><br/><br/><br/><br/>";
    $output .= $script;



    $output .= "<h3>Check:</h3>";
    $output .= "This is your actual Private DNS table:";
    $output .= "<table id='private-dns-table'>";
    $output .= "<tr>";
    $output .= "<th>IP</th>";
    $output .= "<th>name</th>";
    $output .= "<th>updated on </th>";
    $output .= "<tr>";
    $output .= "<td>" .   \Drupal::state()->get('private_dns_ip_0'  , null); ;
    $output .= "<td>" .   \Drupal::state()->get('private_dns_name_0'  , null);     ;
    $output .= "<td>" .   \Drupal::state()->get('private_dns_timestamp_0'  , null);  ;
    $output .= "</th>";
    $output .= "";
    $output .= "";
    $output .= "</table>";


    $output .= '<h2> <b>B.</b> ' . t('Update the /etc/hosts file of your client. Run the script below via crontab') . '</h2>';

    $script  = "<br/><br/><code>\r\n";
    $script .= "#! /bin/bash<br/>";
    $script .= "IP=\"'wget -qO- ".$domain_with_schema.PRIVATE_DNS_BASE_CALL.$args[2]."/". PRIVATE_DNS_KEY   ."'\"<br/>";
    //$script .= "#IP=$(dig +short myip.opendns.com @resolver1.opendns.com)<br/>";
    $script .= "HOST=\"".$args[2]."\"<br/>";
    $script .= "sed -i \"/\$HOST/ s/.*/\$IP\t\$HOST/g\" /etc/hosts  <br/>";
    $script .= "</code><br/><br/><br/><br/>";
    $output .= $script;




    return array(
      '#type' => 'markup',
      '#markup' => $output,
    );
  }





}
